/**
 * Generates a new project with TypeORM.
 */
export declare class InitCommand {
    command: string;
    describe: string;
    builder(yargs: any): any;
    handler(argv: any): Promise<void>;
    /**
     * Gets contents of the ormconfig file.
     */
    protected static getOrmConfigTemplate(): string;
    /**
     * Gets contents of the ormconfig file.
     */
    protected static getTsConfigTemplate(): string;
    /**
     * Gets contents of the user entity.
     */
    protected static getUserEntityTemplate(): string;
    /**
     * Gets contents of the main (index) application file.
     */
    protected static getAppIndexTemplate(): string;
    /**
     * Gets contents of the new package.json file.
     */
    protected static getPackageJsonTemplate(): string;
    /**
     * Gets contents of the new docker-compose.yml file.
     */
    protected static getDockerComposeTemplate(): string;
    /**
     * Gets contents of the new readme.md file.
     */
    protected static getReadmeTemplate(options: {
        docker: boolean;
    }): string;
    /**
     * Appends to a given package.json template everything needed.
     */
    protected static appendPackageJson(packageJsonContents: string): string;
}
